﻿Public Class Tresorknacker
    Public Code As String
    Dim SpielLäuft As Boolean = False
    Dim Eingabe As String = ""
    Dim Code_gesplittet() As String
    Public Spiel_Gewonnen As Boolean = False
    Dim Durchgang As Integer
    Dim aktuelles_Label As Label
    Private Sub Tresorknacker_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        Menü.Hide()

        For Each _txtCode As MaskedTextBox In Controls.OfType(Of MaskedTextBox)
            _txtCode.Enabled = False
        Next

        For Each _lblCode As Label In Controls.OfType(Of Label)
            If _lblCode.Name IsNot "lblAnzeige" And _lblCode.Name IsNot "lblHinweis" Then
                _lblCode.Enabled = False
            End If
        Next

    End Sub

    Private Sub Tresorknacker_FormClosed(sender As Object, e As FormClosedEventArgs) Handles MyBase.FormClosed
        Menü.Visible = True
    End Sub

    Private Function Code_generieren() As String 'Generiert einen vierstelligen Code zwischen 0 und 9 im Format 1-2-3-4, um den Code Splitten zu können
        Dim Code As String
        Dim rnd As New Random

        Code = rnd.Next(0, 10) & "-" & rnd.Next(0, 10) & "-" & rnd.Next(0, 10) & "-" & rnd.Next(0, 10)
        Return Code
    End Function

    Private Function Eingabe_prüfen() As String

        'Die Eingabe in vier Teile aufteilen 
        Dim txt_Eingabe() As String = Eingabe.Split("-"c)

        'Prüfen, ob alle vier Teile der Eingabe Zahlen sind
        For i As Integer = 0 To 3
            If Not Integer.TryParse(txt_Eingabe(i), 0) Then
                Eingabe = ""
                Return ""
                Exit Function
            End If
        Next

        'Den generierten Code ins splitten (Code_gesplittet ist ein Array)
        Code_gesplittet = Code.Split("-"c)

        'Den gsplitteten Code aus dem Array herausholen und im Format 1234 speichern
        Dim Code_ungesplittet As String = ""
        For x As Integer = 0 To 3
            Code_ungesplittet = Code_ungesplittet & Code_gesplittet(x)
        Next


        'Prüfen, welcher Teil der Eingabe mit dem Code übereinstimmt
        Dim lbl_text As String = ""
        For a As Integer = 0 To 3
            If txt_Eingabe(a) = Code_gesplittet(a) Then
                lbl_text = lbl_text & txt_Eingabe(a)
            Else
                lbl_text = lbl_text & "X"
            End If
        Next

        'Prüfen, ob der Code schon ganz erraten wurde
        If lbl_text = Code_ungesplittet Then
            Return "fertig"
        Else
            Return lbl_text
        End If

    End Function

    Private Sub CmdBeginnen_Click(sender As Object, e As EventArgs) Handles cmdBeginnen.Click
        If SpielLäuft = False Then

            'Einen zufälligen Code erhalten
            Code = Code_generieren()

            'Speichern, dass gerade ein Spiel läuft
            SpielLäuft = True

            'Die erste Eingabe freigeben
            Versuch_1()
        End If
    End Sub

    Private Sub txtCode_KeyDown(sender As Object, e As KeyEventArgs) Handles txtCode1.KeyDown, txtCode2.KeyDown, txtCode3.KeyDown, txtCode4.KeyDown, txtCode5.KeyDown, txtCode6.KeyDown, txtCode7.KeyDown, txtCode8.KeyDown

        'Ermitteln, welche MaskedTextBox das KeyDown-Event ausgelöst hat
        Dim txt_sender As MaskedTextBox = DirectCast(sender, MaskedTextBox)

        If e.KeyCode = Keys.Enter Then

            'Die Eingabe speichern
            Eingabe = txt_sender.Text

            'Die Eingabe auf einen Treffer prüfen
            Dim Ergebnis As String = Eingabe_prüfen()

            'Aktuellen Durchgang ermitteln
            Select Case True
                Case txt_sender Is txtCode1
                    Durchgang = 1
                    aktuelles_Label = lblCode1
                Case txt_sender Is txtCode2
                    Durchgang = 2
                    aktuelles_Label = lblCode2
                Case txt_sender Is txtCode3
                    Durchgang = 3
                    aktuelles_Label = lblCode3
                Case txt_sender Is txtCode4
                    Durchgang = 4
                    aktuelles_Label = lblCode4
                Case txt_sender Is txtCode5
                    Durchgang = 5
                    aktuelles_Label = lblCode5
                Case txt_sender Is txtCode6
                    Durchgang = 6
                    aktuelles_Label = lblCode6
                Case txt_sender Is txtCode7
                    Durchgang = 7
                    aktuelles_Label = lblCode7
                Case txt_sender Is txtCode8
                    Durchgang = 8
                    aktuelles_Label = lblCode8
            End Select

            If Ergebnis Is Nothing Then

                aktuelles_Label.Text = "XXXX"

            ElseIf Ergebnis <> "" And Ergebnis IsNot "fertig" Then

                txt_sender.Enabled = False
                aktuelles_Label.Text = Ergebnis
                aktuelles_Label.Enabled = False

                'Den nächsten Versuch bestimmen und einleiten
                Select Case Durchgang
                    Case 1
                        Versuch_2()
                    Case 2
                        Versuch_3()
                    Case 3
                        Versuch_4()
                    Case 4
                        Versuch_5()
                    Case 5
                        Versuch_6()
                    Case 6
                        Versuch_7()
                    Case 7
                        Versuch_8()
                    Case 8
                        Verloren()
                End Select

            ElseIf Ergebnis <> "" And Ergebnis = "fertig" Then
                Gewonnen()
            End If

        End If
    End Sub

    Private Sub Versuch_1()
        txtCode1.Enabled = True
        txtCode1.Focus()
        lblCode1.Enabled = True
    End Sub
    Private Sub Versuch_2()
        txtCode2.Enabled = True
        txtCode2.Focus()
        lblCode2.Enabled = True
    End Sub

    Private Sub Versuch_3()
        txtCode3.Enabled = True
        txtCode3.Focus()
        lblCode3.Enabled = True
    End Sub

    Private Sub Versuch_4()
        txtCode4.Enabled = True
        txtCode4.Focus()
        lblCode4.Enabled = True
    End Sub

    Private Sub Versuch_5()
        txtCode5.Enabled = True
        txtCode5.Focus()
        lblCode5.Enabled = True
    End Sub

    Private Sub Versuch_6()
        txtCode6.Enabled = True
        txtCode6.Focus()
        lblCode6.Enabled = True
    End Sub

    Private Sub Versuch_7()
        txtCode7.Enabled = True
        txtCode7.Focus()
        lblCode7.Enabled = True
    End Sub

    Private Sub Versuch_8()
        txtCode8.Enabled = True
        txtCode8.Focus()
        lblCode8.Enabled = True
    End Sub

    Private Sub Gewonnen()
        'MessageBox.Show("Gewonnen. Du kannst unbeobachtet mit dem Zaster verschwinden.", "Tresorknacker", MessageBoxButtons.OK, MessageBoxIcon.Information)
        Spiel_Gewonnen = True
        Meldung.ShowDialog(Me)
        cmdAbbrechen.PerformClick() 'Alles wieder zurücksetzen
    End Sub

    Private Sub Verloren()
        'MessageBox.Show("Verloren. Die Polizei hat das Haus umstellt. Der Code war " & Code & " .", "Tresorknacker", MessageBoxButtons.OK, MessageBoxIcon.Error)
        Spiel_Gewonnen = False
        Meldung.ShowDialog(Me)
        cmdAbbrechen.PerformClick() 'Alles wieder zurücksetzen
    End Sub
    Private Sub CmdAbbrechen_Click(sender As Object, e As EventArgs) Handles cmdAbbrechen.Click

        'Textboxen zurücksetzen und sperren
        For Each _txtCode As MaskedTextBox In Controls.OfType(Of MaskedTextBox)
            _txtCode.Text = ""
            _txtCode.Enabled = False
        Next

        'Labels zurücksetzen und Sperren
        For Each _lblCode As Label In Controls.OfType(Of Label)
            If _lblCode.Name IsNot "lblAnzeige" And _lblCode.Name IsNot "lblHinweis" Then
                _lblCode.Text = "XXXX"
                _lblCode.Enabled = False
            End If
        Next

        'Variablen zurücksetzen
        Code = ""
        SpielLäuft = False
        Eingabe = ""
        Spiel_Gewonnen = False
    End Sub
End Class